import cv2
import numpy as np
import matplotlib.pyplot as plt
plt.rcParams['font.sans-serif'] = ['simHei']
plt.rcParams['axes.unicode_minus'] = False
from Butterworth import filter

# 读取照片
image_characterTestPattern2 = cv2.imread("file/characterTestPattern2.jpg", cv2.IMREAD_GRAYSCALE)

# 利用巴特沃斯滤波器进行处理
image_characterTestPattern2_Butterworth1 = filter(image_characterTestPattern2, 10, type='lp')
image_characterTestPattern2_Butterworth2 = filter(image_characterTestPattern2, 100, type='lp')
image_characterTestPattern2_Butterworth3 = filter(image_characterTestPattern2, 1000, type='lp')

# 展示图像
plt.subplot(2,2,1)
plt.imshow(image_characterTestPattern2, cmap='gray')
plt.title('原图')
plt.axis('off')

plt.subplot(2,2,2)
plt.imshow(image_characterTestPattern2_Butterworth1, cmap='gray')
plt.title('D0 = 10')
plt.axis('off')

plt.subplot(2,2,3)
plt.imshow(image_characterTestPattern2_Butterworth2, cmap='gray')
plt.title('D0 = 100')
plt.axis('off')

plt.subplot(2,2,4)
plt.imshow(image_characterTestPattern2_Butterworth3, cmap='gray')
plt.title('D0 = 1000')
plt.axis('off')

plt.tight_layout()
plt.show()