import cv2
import numpy as np
import matplotlib.pyplot as plt
plt.rcParams['font.sans-serif'] = ['simHei']
plt.rcParams['axes.unicode_minus'] = False
from High_Frequency_Emphasis import apply_hfe_filter

# 读取照片
image_boy34 = cv2.imread("file/boy34.jpg", cv2.IMREAD_GRAYSCALE)

# 利用HFE滤波器处理
k1 = 0.8
k2 = 0.2

k11 = 0.5
k22 = 0.5

k111 = 0.2
k222 = 0.8

image_boy341 = apply_hfe_filter(image_boy34, k1, k2)
image_boy342 = apply_hfe_filter(image_boy34, k11, k22)
image_boy343 = apply_hfe_filter(image_boy34, k111, k222)

# 展示图像
plt.subplot(2,2,1)
plt.imshow(image_boy34, cmap='gray')
plt.title('原图')
plt.axis('off')

plt.subplot(2,2,2)
plt.imshow(image_boy341, cmap='gray')
plt.title('HFE滤波器K1=0.8,K2=0.2')
plt.axis('off')

plt.subplot(2,2,3)
plt.imshow(image_boy342, cmap='gray')
plt.title('HFE滤波器K1=0.5,K2=0.5')
plt.axis('off')

plt.subplot(2,2,4)
plt.imshow(image_boy343, cmap='gray')
plt.title('HFE滤波器K1=0.2,K2=0.5')
plt.axis('off')

plt.tight_layout()
plt.show()