import numpy as np

def gaussian_high_pass_filter(shape, cutoff):
    rows, cols = shape
    crow, ccol = rows // 2 , cols // 2
    x = np.arange(0, cols)
    y = np.arange(0, rows)
    x, y = np.meshgrid(x, y)
    distance = np.sqrt((x - ccol)**2 + (y - crow)**2)
    high_pass = 1 - np.exp(-(distance**2) / (2 * (cutoff**2)))
    return high_pass