# <p align="center">重构图像&图像滤波</p>
## 运行库
cv2、matplotlib、numpy<br>
Butterworth.py、Gaussian_Highpass.py、High_Frequency_Emphasis.py
## 利用频谱幅度和相位角重构图像
对照片进行快速傅里叶变换获取频谱幅度和相位角。<br>
利用获取到的频谱幅度和相位角对图像进行重构。
## 将频谱幅度的最亮点移到中心
```c
shift_woman = np.fft.fftshift(dft_woman)
image_woman_translation = np.log(np.abs(shift_woman))
```
### Woman_Square.py
分别利用woman.jpg/squart.jpg的频谱幅度和squart.jpg/woman.jpg的相位角进行图像重构。<br>
将woman频谱幅度的最亮点移到中心。<br>
程序效果展示如下。<br>
![Woman_Square](/Result_Photo_FFT/assignment3.png#pic_center)
## 不填充、零填充、原图填充并进行平滑滤波
### Filtering_Padding.py
程序效果展示如下。<br>
![All_Filtering](/Result_Photo_Filtering/1.All_Filtering.png#pic_center)
## 巴特沃斯低通滤波器平滑图像
### Filtering_Butterworth.py
调用Butterworth.py程序中的filter函数实现巴特沃斯滤波器。<br>
D0分别设置为10、100、1000。<br>
程序效果展示如下。<br>
![Butterworth_All](/Result_Photo_Filtering/2.Butterworth_All.png#pic_center)
## 高斯高通滤波器锐化图像
### Filtering_Gaussian_Highpass.py
调用Gaussian_Highpass.py程序中的gaussian_high_pass_filter函数实现高斯高通滤波器。<br>
D0分别设置为10、100、1000。<br>
程序效果展示如下。<br>
![Butterworth_All](/Result_Photo_Filtering/3.Gaussian_Highpass_All.png#pic_center)
## HFE滤波器锐化图像并叠加到原图
### Filtering_HFE.py
调用High_Frequency_Emphasis.py程序中的apply_hfe_filter函数实现HFE滤波器。<br>
三组[K1,K2]分别设置为[0.8,0.2]、[0.5,0.5]、[0.2,0.8]。<br>
程序效果展示如下。<br>
![HFE_All](/Result_Photo_Filtering/4.HFE_All.png#pic_center)

## <p align="center">代码[`仓库`](http://dreamlife.top:13000/Cx330_HomeWork/FFT_And_Filtering)地址</p>